<html>
<head>
	<script>
		async function fetchCurrentAuth() {
			const response = await fetch('/current-auth');
			const auth = await response.json();

			console.log(auth);

			document.getElementById('logged-in').innerHTML = auth.isLoggedIn ? `<strong>${auth.data.email}</strong>` : '<em>not logged in</em>';
		}

		async function setResult(response) {
			let data = await response.text();

			try {
				const json = JSON.parse(data);
				data = JSON.stringify(json, null, 4);
			} catch(e) {}

			document.getElementById('result').innerHTML = data;
		}

		async function logIn(e) {
			e.preventDefault();
			const form = e.target;

			const type = form.elements['type'].value;
			const strategy = form.elements['strategy'].value;

			const cognitoPool = form.elements['cognito_pool'].value;
			const cognitoClient = form.elements['cognito_client'].value;

			const email = form.elements['email'].value || form.elements['email'].placeholder;
			const password = form.elements['password'].value || form.elements['password'].placeholder;

			console.log(email, password);

			let response;

			if (type === 'rest') {
				response = await fetch(`/login/${strategy}?email=${email}&password=${password}`);
			} else if (type === 'graphql') {
				response = await fetch('/graphql', {
					method: 'POST',
					headers: {
						'Content-Type': 'application/json',
						'Accept': 'application/json',
					},
					body: JSON.stringify({query: `mutation { ${strategy}LogIn(email: "${email}", password: "${password}") }`})
				});
			}

			setResult(response);
			fetchCurrentAuth();
		}

		async function logOut() {
			console.log("log out");
			const type = document.querySelector('select[name=type]').value;
			console.log(type);

			let response;
			if (type === 'rest') {
				response = await fetch('/logout');
			} else if (type === 'graphql') {
				response = await fetch('/graphql', {
					method: 'POST',
					headers: {
						'Content-Type': 'application/json',
						'Accept': 'application/json',
					},
					body: JSON.stringify({query: "mutation { logOut }"})
				});
			}

			setResult(response);
			fetchCurrentAuth();
		}

		const getCookieValue = (name) => {
			return document.cookie.match('(^|;)\\s*' + name + '\\s*=\\s*([^;]+)')?.pop() || '';
		}
	</script>
</head>
<body>
	Logged in: <span id="logged-in">...</span>

	<hr />

	<form onSubmit="logIn(event)">
		<select name="type">
			<option value="rest">REST</option>
			<option value="graphql">GraphQL</option>
		</select>
		<select name="strategy">
			<option value="local">Local</option>
			<option value="cognito">Cognito</option>
		</select>
		<div id="cognito-config" style="display: none">
			<div>Cognito pool ID: <input type="text" name="cognito_pool" data-cookie /></div>
			<div>Cognito client ID: <input type="text" name="cognito_client" data-cookie /></div>
		</div>
		<div>Email: <input type="text" name="email" placeholder="test@example.com" /></div>
		<div>Password: <input type="text" name="password" placeholder="pa$$W0rd" /></div>
		<button type="submit" id="login">Log in</button>
		<button type="button" id="logout" onclick="logOut()">Log out</button>
	</form>

	<hr />

	<div>
		result:
		<pre id="result"></pre>
	</div>
<script>
	document.querySelector('select[name=strategy]').addEventListener('change', (e) => {
		const strategy = e.target.value;
		const cognitoConfig = document.getElementById('cognito-config');
		cognitoConfig.style.display = strategy === 'cognito' ? 'block' : 'none';
	});

	document.querySelectorAll('[data-cookie]').forEach(el => {
		el.addEventListener('keyup', (e) => {
			const {name, value} = e.target;
			document.cookie = `${name}=${value}`;
		});

		el.value = getCookieValue(el.name);
	});

	fetchCurrentAuth();
</script>
</body>
</html>
